Index: trunk/src/world_entities/weapons/aim.cc
===================================================================
--- trunk/src/world_entities/weapons/aim.cc	(revision 5772)
+++ trunk/src/world_entities/weapons/aim.cc	(revision 5779)
@@ -81,4 +81,5 @@
 
   this->text = new Text();
+  this->text->setLayer(this->getLayer());
   this->text->setParent2D(this);
   this->text->setRelCoor2D(10, -50);
Index: trunk/src/world_entities/weapons/guided_missile.cc
===================================================================
--- trunk/src/world_entities/weapons/guided_missile.cc	(revision 5772)
+++ trunk/src/world_entities/weapons/guided_missile.cc	(revision 5779)
@@ -66,5 +66,5 @@
 
   /* this is normaly done by World.cc by deleting the ParticleEngine */
-  if (GuidedMissile::trailParticles != NULL && ClassList::getList(CL_TEST_BULLET)->getSize() <= 1)
+  if (GuidedMissile::trailParticles != NULL && ClassList::getList(CL_TEST_BULLET)->size() <= 1)
   {
     if (ClassList::exists(GuidedMissile::trailParticles, CL_PARTICLE_SYSTEM))
@@ -72,5 +72,5 @@
     GuidedMissile::trailParticles = NULL;
   }
-  if (GuidedMissile::explosionParticles != NULL && ClassList::getList(CL_TEST_BULLET)->getSize() <= 1)
+  if (GuidedMissile::explosionParticles != NULL && ClassList::getList(CL_TEST_BULLET)->size() <= 1)
   {
     if (ClassList::exists(GuidedMissile::explosionParticles, CL_PARTICLE_SYSTEM))
Index: trunk/src/world_entities/weapons/laser.cc
===================================================================
--- trunk/src/world_entities/weapons/laser.cc	(revision 5772)
+++ trunk/src/world_entities/weapons/laser.cc	(revision 5779)
@@ -63,5 +63,5 @@
 
   /* this is normaly done by World.cc by deleting the ParticleEngine */
-  if (Laser::explosionParticles != NULL && ClassList::getList(CL_LASER)->getSize() <= 1)
+  if (Laser::explosionParticles != NULL && ClassList::getList(CL_LASER)->size() <= 1)
   {
     //if (ClassList::exists(Laser::explosionParticles, CL_PARTICLE_SYSTEM))
Index: trunk/src/world_entities/weapons/rocket.cc
===================================================================
--- trunk/src/world_entities/weapons/rocket.cc	(revision 5772)
+++ trunk/src/world_entities/weapons/rocket.cc	(revision 5779)
@@ -62,5 +62,5 @@
 
   /* this is normaly done by World.cc by deleting the ParticleEngine */
-  if (Rocket::trailParticles != NULL && ClassList::getList(CL_TEST_BULLET)->getSize() <= 1)
+  if (Rocket::trailParticles != NULL && ClassList::getList(CL_TEST_BULLET)->size() <= 1)
   {
     if (ClassList::exists(Rocket::trailParticles, CL_PARTICLE_SYSTEM))
@@ -68,5 +68,5 @@
     Rocket::trailParticles = NULL;
   }
-  if (Rocket::explosionParticles != NULL && ClassList::getList(CL_TEST_BULLET)->getSize() <= 1)
+  if (Rocket::explosionParticles != NULL && ClassList::getList(CL_TEST_BULLET)->size() <= 1)
   {
     if (ClassList::exists(Rocket::explosionParticles, CL_PARTICLE_SYSTEM))
Index: trunk/src/world_entities/weapons/test_bullet.cc
===================================================================
--- trunk/src/world_entities/weapons/test_bullet.cc	(revision 5772)
+++ trunk/src/world_entities/weapons/test_bullet.cc	(revision 5779)
@@ -62,5 +62,5 @@
 
   /* this is normaly done by World.cc by deleting the ParticleEngine */
-  if (TestBullet::trailParticles != NULL && ClassList::getList(CL_TEST_BULLET)->getSize() <= 1)
+  if (TestBullet::trailParticles != NULL && ClassList::getList(CL_TEST_BULLET)->size() <= 1)
   {
     if (ClassList::exists(TestBullet::trailParticles, CL_PARTICLE_SYSTEM))
@@ -68,5 +68,5 @@
     TestBullet::trailParticles = NULL;
   }
-  if (TestBullet::explosionParticles != NULL && ClassList::getList(CL_TEST_BULLET)->getSize() <= 1)
+  if (TestBullet::explosionParticles != NULL && ClassList::getList(CL_TEST_BULLET)->size() <= 1)
   {
     if (ClassList::exists(TestBullet::explosionParticles, CL_PARTICLE_SYSTEM))
Index: trunk/src/world_entities/weapons/weapon_manager.cc
===================================================================
--- trunk/src/world_entities/weapons/weapon_manager.cc	(revision 5772)
+++ trunk/src/world_entities/weapons/weapon_manager.cc	(revision 5779)
@@ -347,9 +347,8 @@
    if (this->targetIterator == NULL)
    {
-     tList<BaseObject>* npcList = ClassList::getList(CL_NPC);
+     std::list<BaseObject*>* npcList = ClassList::getList(CL_NPC);
      if (npcList != NULL)
      {
-       this->targetIterator = npcList->getIterator();
-       this->targetIterator->firstElement();
+       this->targetIterator = npcList->begin();
      }
      else
@@ -357,7 +356,9 @@
    }
 
-   PNode* retNode = dynamic_cast<PNode*>(targetIterator->nextElement());
-   if (retNode == NULL && this->targetIterator->getList()->getSize() > 0)
-     retNode =  dynamic_cast<PNode*>(targetIterator->firstElement());
+   ///FIXME
+//   this->targetIterator++;
+   PNode* retNode = dynamic_cast<PNode*>((*targetIterator));
+//   if (retNode == NULL && this->targetIterator->getList()->getSize() > 0)
+//     retNode =  dynamic_cast<PNode*>(targetIterator->firstElement());
 
    return retNode;
@@ -372,22 +373,13 @@
 PNode* WeaponManager::getDistanceTarget(const PNode* carrier, float distance)
 {
-  tList<BaseObject>* npcList = ClassList::getList(CL_NPC);
+  std::list<BaseObject*>* npcList = ClassList::getList(CL_NPC);
   if (npcList != NULL)
   {
-    tIterator<BaseObject>* npcIT = npcList->getIterator();
-    PNode* tmpNPC = dynamic_cast<PNode*>(npcIT->firstElement());
-    while (tmpNPC != NULL)
-    {
-      if ((carrier->getAbsCoor() - tmpNPC->getAbsCoor()).len() < distance)
-      {
-        delete npcIT;
-        return tmpNPC;
-      }
-      tmpNPC = dynamic_cast<PNode*>(npcIT->nextElement());
-    }
-    delete npcIT;
+    list<BaseObject*>::iterator node;
+    for (node= npcList->begin(); node != npcList->end(); node++)
+      if ((carrier->getAbsCoor() - dynamic_cast<PNode*>(*node)->getAbsCoor()).len() < distance)
+        return dynamic_cast<PNode*>(*node);
   }
   return this->getFixedTarget();
-
 }
 
Index: trunk/src/world_entities/weapons/weapon_manager.h
===================================================================
--- trunk/src/world_entities/weapons/weapon_manager.h	(revision 5772)
+++ trunk/src/world_entities/weapons/weapon_manager.h	(revision 5779)
@@ -110,4 +110,4 @@
     tAnimation<Crosshair>*  crossHairSizeAnim;                        //!< An animation for the crosshair (scaling)
 
-    tIterator<BaseObject>*  targetIterator;                           //!< An iterator for traversion lists of enemies.
+    std::list<BaseObject*>::iterator  targetIterator;                           //!< An iterator for traversion lists of enemies.
 };
